<?php

namespace Drupal\multiple_br_filter\Plugin\Filter;

use Drupal\filter\FilterProcessResult;
use Drupal\filter\Plugin\FilterBase;

/**
 * Provides a filter to remove multiple consecutive <br> tags.
 *
 * @Filter(
 *   id = "remove_multiple_br",
 *   title = @Translation("Remove multiple consecutive <code>&lt;br&gt;</code> tags"),
 *   description = @Translation("Collapses multiple consecutive <code>&lt;br&gt;</code> tags into a single <code>&lt;br&gt;</code>."),
 *   type = Drupal\filter\Plugin\FilterInterface::TYPE_TRANSFORM_IRREVERSIBLE
 * )
 */
class MultipleBrFilter extends FilterBase {

  /**
   * {@inheritdoc}
   */
  public function process($text, $langcode) {
    // Replace multiple <br> tags with a single <br />.
    $text = preg_replace('/(<br\s*\/?>\s*){2,}/i', '<br />', $text);
    return new FilterProcessResult($text);
  }

}
